	;
	; 2048 - Coded by Csabo of LOD, 2014-04-06
	;
	; Feel free to use to source.
	; Be sure to check out the various included modules,
	; they are meant to be reused.
	;
	org $1001-2
	dw  $1001
	
	dw $1019,0
	db $9E,$C2,"(44)",$AC,"256",$AA,$C2,"(43)",$AA,"26"
	db 0,0,0

pos_corner = $0C30
grid_width = 4
grid_height = 4

dst			= $D0
dstc			= $D2
src			= $D4
winw			= $D6
winh			= $D7
winc			= $D8

xloop			= $D9
yloop			= $DA
xdest			= $DB
ydest			= $DC
current_tile		= $DD
valid_move		= $DE
win_flag		= $DF

; random
rand			= $E0	; 32 bit

; keyboard
keyb_ptr		= $E4
keyb_lastkey		= $E6
keyb_repeatcnt		= $E7
keyb_shift		= $E8
keyb_repeat_init	= 20	; constant
keyb_repeat		= 4	; constant

; highscore
hs_ptr			= $E9
hs_data			= $2000
hs_scores		= 10
hs_namelen		= 5
hs_scorelen		= 5

; string input
si_curpos		= $EB	; zp
si_maxlen		= $EC	; zp
si_space		= " "	; const: default padding character

DrawWindow	macro	xp, yp, width, height, color
	lda #($0C00+xp+yp*40) & 255
	sta dst
	lda #($0C00+xp+yp*40) >> 8
	sta dst+1
	lda #width
	sta winw
	lda #height
	sta winh
	lda #color
	sta winc
	jsr draw_border
endm

CopyText	macro xp, yp, width, height, sourceAddr
	lda #($0C00+xp+yp*40) & 255
	sta dst
	lda #($0C00+xp+yp*40) >> 8
	sta dst+1
	;
	ldy #width
	ldx #height
	;
	lda #sourceAddr & 255
	sta src
	lda #sourceAddr >> 8
	sta src+1
	;
	jsr copy_text
endm
	
start
	lda #$40		; TED check!
	sta $FF16		; Make sure that:
	lda $FF16		; $FF16 can be read/written
	cmp #$C0		; highest bit is always set
	beq can_start
	;
	ldx #$22		; print message and quit
	ldy #$34		; (VIC20/C64 compatible)
qt1	lda ($2B),y
	jsr $FFD2
	iny
	dex
	bpl qt1
	rts
	;
	db "THIS PROGRAM REQUIRES A C16/PLUS4.",13
	;
can_start
	sei
	sta $FF3F
	;
	lda #$FF
	cmp $FF1D
	bne *-3
	;
	lda #$59
	sta $FF15
	sta $FF19
	;
	jsr ClearHighScores
	;
	jsr InitRandom
new_game
	jsr clear_screen
	;
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	DrawWindow 11, 4, 17, 9, $19 
	CopyText 13, 6, 14, 6, Logo
	;
	jsr sync
	DrawWindow 4, 17, 31, 3, $19
	CopyText 4, 17, 32, 4, Intro
	;
	jsr WaitSpace
	stx rand+0			; initialize random number based on keypress
	sty rand+1
	;
	jsr clear_screen
	;
	lda $FF07
	and #$40
	ora #$04
	sta $FF07
	;
	jsr clear_grid
	jsr clear_score
	jsr add_random
	lda #$00
	sta win_flag
	lda #$01
	sta valid_move
	;
game_loop
	jsr update_score
	jsr draw_grid
	;
	lda win_flag
	bne won_game
	;
	lda valid_move
	beq gl1
	;
	jsr wait_5_frames
	jsr add_random
	jsr draw_grid
	;
gl1	jsr is_gameover
	bcs gameover
	;
	lda #key_table & 255
	ldx #key_table >> 8
	jmp keyboard
	
won_game
	DrawWindow 9, 11, 20, 2, $77
	CopyText 11, 12, 17, 1, Congratulations
	;
	jsr WaitSpace
	;
gameover
	jsr CheckHighScore
	bmi not_on_highscore_list
	;
	DrawWindow 12, 8, 14, 7, $71
	CopyText 14, 10, 11, 4, EnterYourName
	;
	lda #hs_namelen
	sta si_maxlen
	;
	jsr StringInputClear
	jsr StringInput
	;
	jsr InsertHighScore
	;
not_on_highscore_list
	DrawWindow 12, 4, 14, 15, $11
	;
	ldx #$C
hs1	lda HighScores,x
	sta $0D4D-80,x
	dex
	bpl hs1
	;
	jsr DisplayHighScores
	;
	jsr WaitSpace
	;
	jmp new_game
	
WaitSpace
	ldx #$00		; two counters, will have random value
	ldy #$00		; based on how long space/fire is pressed
	;
ws0	inx
	;
	lda #$7F
	jsr QueryKeyboard
	and #$10		; Query keyboard for "Space"
	beq ws1
	;
	lda #$F9
	jsr QueryJoystick
	and #$40
	bne ws0
	;
ws2	iny
	;
	lda #$F9
	jsr QueryJoystick
	and #$40		; Query for fire button
	beq ws2
	;
	rts
	;
ws1	iny
	;
	lda #$7F
	jsr QueryKeyboard
	and #$10
	beq ws1
	;
	rts
	
QueryKeyboard
	sta $FD30
QueryJoystick
	sta $FF08
	lda $FF08
	rts
	
wait_5_frames
	ldx #$05
	db $2C
sync	ldx #$00
	lda #$CC
wf1	cmp $FF1D
	bne *-3
	cmp $FF1D
	beq *-3
	dex
	bpl wf1
	rts
	
	;
	; print score on screen
	;
update_score
	ldx #hs_scorelen-1
us1	lda Score,x
	clc
	adc #$30
	sta $0C26-hs_scorelen,x
	dex
	bpl us1
	rts
	
	;
	; add a random tile to the grid
	;	
add_random
ar1	jsr GetRandom
	pha
	and #$03		; lowest two bits are X coord
	tax
	stx xloop
	pla
	lsr a
	lsr a
	and #$03		; next two bits are y coord 
	tay
	sty yloop
	jsr get_tile		; ensure tile is empty
	bne ar1			; otherwise generate new random coords
	;
	jsr GetRandom
	cmp #$E7		; 90% of time it's 2 tile
	bcs ar2
	;
	lda #$01		; 2 tile
	db $2C
ar2	lda #$02		; 4 tile
	ldx xloop
	ldy yloop
	jsr set_tile
	rts
	
	;
	; draw the entire grid
	;
draw_grid
	jsr sync
	;
	ldx #$00
	ldy #$00
	;
dg1	stx xloop
	sty yloop
	jsr get_tile
	ldx xloop
	ldy yloop
	jsr draw_one_tile
	;
	ldx xloop
	ldy yloop
	inx
	cpx #grid_width
	bne dg1
	ldx #$00
	iny
	cpy #grid_height
	bne dg1
	;
	rts
	
	;
	; clear the grid (all blank tiles)
	;
clear_grid
	ldx #$00
	lda #$00
cg1	sta grid,x
	inx
	cpx #grid_width*grid_height
	bne cg1
	rts
	
	; x,y = pos
	; a = tile
set_tile
	pha
	tya
	asl a
	asl a
	sta st1+1
	txa
	clc
st1	adc #$00
	tax
	pla
	sta grid,x
	rts

	; x,y = pos
	; return: a = tile	
get_tile
	tya
	asl a
	asl a
	sta gt1+1
	txa
	clc
gt1	adc #$00
	tax
	lda grid,x
	rts
	
	; x,y = pos
	; a = tile
draw_one_tile
	pha
	;
	jsr get_tile_screen_pos
	;
	pla
	pha
	tax
	lda tile_colors,x
	sta dot3+1
	;
	ldx #$ff
	ldy #$00
dot2	inx
	lda tile,x
	bne dot1
	;
	tya
	clc
	adc #35
	tay
	bne dot2
	;
dot1	sta (dst),y
dot3	lda #$71
	sta (dstc),y
	iny
	cpx #28
	bne dot2
	;
	pla
	asl a
	asl a
	tax
	ldy #$50
dot4	lda tile_text,x
	ora #$80
	sta (dst),y
	inx
	iny
	cpy #$54
	bne dot4 
	;
	rts

dst_add_40
	lda #40
dst_add	clc
	adc dst
	sta dst
	sta dstc
	bcc *+6
	inc dst+1
	inc dstc+1
	rts

	; x,y = pos
	; modifies a
	; -> dst = address
get_tile_screen_pos
	stx gtp1+1
	tya
	asl a
	asl a
	clc
gtp1	adc #$00
	asl a
	tax
	lda pos_table,x
	sta dst
	sta dstc
	lda pos_table+1,x
	sta dst+1
	and #$FB
	sta dstc+1
	rts

is_gameover
	ldx #$00
igo2	lda grid,x
	beq igo1		; empty space = no game over
	inx
	cpx #grid_width*grid_height
	bne igo2
	;
	; --- check if anything can be merged
	;
	ldx #$00
	ldy #$00
igo3	stx xloop	
	sty yloop
	jsr get_tile
	sta current_tile
	;
	ldx xloop
	inx
	cpx #grid_width
	beq igo4
	ldy yloop
	jsr get_tile
	cmp current_tile
	beq igo1		; yes, two same tiles are side-by-side
	;
igo4	ldx xloop
	ldy yloop
	iny
	cpy #grid_height
	beq igo5
	jsr get_tile
	cmp current_tile
	beq igo1		; yes, two same tiles are below each other
	;
igo5	ldx xloop
	ldy yloop
	inx
	cpx #grid_width
	bne igo3
	;
	ldx #$00
	iny
	cpy #grid_height
	bne igo3
	;
	sec
	rts
	
igo1	clc
	rts
	
MoveLeft
	lda #$00
	sta valid_move
	;
	ldy #$00
ml1	sty yloop
	;
	ldx #$00
ml3	stx xloop
	;
	ldy yloop
	jsr get_tile
	beq ml2			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
ml4	ldy ydest
	dec xdest
	ldx xdest
	cpx #$FF		; no empty space, continue loop
	beq ml2
	jsr get_tile
	bne ml5
	;
	jsr move_tile
	jmp ml4
	;	
ml5	cmp current_tile
	bne ml2
	;
	jsr merge_tile
	;
ml2	ldx xloop
	inx
	cpx #grid_width
	bne ml3
	;
	ldy yloop
	iny
	cpy #grid_height
	bne ml1
	;
	jmp game_loop
	
MoveUp
	lda #$00
	sta valid_move
	;
	ldx #$00
mu1	stx xloop
	;
	ldy #$00
mu3	sty yloop
	;
	ldx xloop
	jsr get_tile
	beq mu2			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
mu4	ldx xdest
	dec ydest
	ldy ydest
	cpy #$FF		; no empty space, continue loop
	beq mu2
	jsr get_tile
	bne mu5
	;
	jsr move_tile
	jmp mu4
	;	
mu5	cmp current_tile
	bne mu2
	;
	jsr merge_tile
	;
mu2	ldy yloop
	iny
	cpy #grid_height
	bne mu3
	;
	ldx xloop
	inx
	cpx #grid_width
	bne mu1
	;
	jmp game_loop
	
MoveRight
	lda #$00
	sta valid_move
	;
	ldy #$00
mr1	sty yloop
	;
	ldx #grid_width-2
mr3	stx xloop
	;
	ldy yloop
	jsr get_tile
	beq mr2			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
mr4	ldy ydest
	inc xdest
	ldx xdest
	cpx #grid_width		; no empty space, continue loop
	beq mr2
	jsr get_tile
	bne mr5
	;
	jsr move_tile
	jmp mr4
	;	
mr5	cmp current_tile
	bne mr2
	;
	jsr merge_tile
	;
mr2	ldx xloop
	dex
	bpl mr3
	;
	ldy yloop
	iny
	cpy #grid_height
	bne mr1
	;
	jmp game_loop
	
MoveDown
	lda #$00
	sta valid_move
	;
	ldx #$00
md1	stx xloop
	;
	ldy #grid_height-2
md3	sty yloop
	;
	ldx xloop
	jsr get_tile
	beq md2			; empty tile, nothing to do
	;
	; -- move tile down (if possible)
	;
	sta current_tile
	;
	ldx xloop
	stx xdest
	ldy yloop
	sty ydest
	;
md4	ldx xdest
	inc ydest
	ldy ydest
	cpy #grid_height	; no empty space, continue loop
	beq md2
	jsr get_tile
	bne md5
	;
	jsr move_tile
	jmp md4
	;	
md5	cmp current_tile
	bne md2
	;
	jsr merge_tile
	;
md2	ldy yloop
	dey
	bpl md3
	;
	ldx xloop
	inx
	cpx #grid_width
	bne md1
	;
	jmp game_loop
	
	;
	; Move one tile from xloop/yloop to xdest/ydest
	;
move_tile
	inc valid_move
	;
	ldx xloop
	ldy yloop
	lda #$00		; blank to original place
	jsr set_tile
	;
	ldx xdest
	ldy ydest
	lda current_tile	; tile to new place
	jsr set_tile
	;
	ldx xdest
	stx xloop
	ldy ydest
	sty yloop
	rts
	
merge_tile
	inc valid_move
	;
	ldx xloop
	ldy yloop
	lda #$00
	jsr set_tile
	;
	ldx xdest
	ldy ydest
	jsr get_tile
	;
	clc
	adc #$01
	pha
	ldx xdest
	ldy ydest
	jsr set_tile
	;
	pla
	pha
	asl a
	asl a
	asl a
	tax
	ldy #$00
mt1	lda tile_score,x
	sta ScoreAddSub,y
	inx
	iny
	cpy #hs_scorelen
	bne mt1
	jsr AddScore
	;
	pla
	cmp #11			; 2048 tile?
	bne mt2
	;
	lda #$01
	sta win_flag		; won
	;
mt2	rts
	
AddScore
	ldx #hs_scorelen-1
as1	lda Score,x
	clc
	adc ScoreAddSub,x
	cmp #$0A
	bcc NoOverflow
	;
	cpx #$00
	beq ScoreOver99999
	inc ScoreAddSub-1,x
	sec
	sbc #$0A
NoOverflow
	sta Score,x
	dex
	bpl as1
	;
	rts
	
ScoreOver99999
	lda #$09
	db $2C
ScoreBelowZero
	lda #$00	
	ldx #$04
sbz1	sta Score,x
	dex
	bpl sbz1
	;
	rts
	
clear_score
	ldx #hs_scorelen-1
	lda #$00
cs1	sta Score,x
	dex
	bpl cs1
	rts
	
	;
	; Clears the high score list
	;
ClearHighScores
	lda #hs_data & 255		; reset pointer
	sta hs_ptr
	lda #hs_data >> 8
	sta hs_ptr+1
	;
	ldx #hs_scores-1		; loop through each score
	;
chs0	ldy #$00
	;
	lda #$00
chs1	sta (hs_ptr),y			; fill score
	iny
	cpy #hs_scorelen
	bne chs1
	;
	tya
	jsr hs_ptr_add			; inc pointer
	;
	ldy #$00
	lda #"."
chs2	sta (hs_ptr),y			; fill name
	iny
	cpy #hs_namelen
	bne chs2
	;
	tya
	jsr hs_ptr_add			; inc pointer
	;
	dex
	bpl chs0
	;
	rts 
	
DisplayHighScores
	jsr hs_ptr_reset
	;
	lda #$4E
	sta dst
	lda #$0D
	sta dst+1
	;
	lda #$00
	sta yloop
	;
dhs0	ldy #$00
dhs2	lda (hs_ptr),y	; score
	ora #$30
	sta (dst),y
	iny
	cpy #hs_scorelen
	bne dhs2
	;
	tya
	jsr hs_ptr_add
	;
	; ---
	;
	lda #hs_namelen+1
	jsr dst_add
	;
	ldy #$00
dhs1	lda (hs_ptr),y	; name
	sta (dst),y
	iny
	cpy #hs_namelen
	bne dhs1
	;
	tya
	jsr hs_ptr_add
	;
	lda #(40-1-hs_scorelen)
	jsr dst_add
	;
	; ---
	;
	inc yloop
	lda yloop
	cmp #hs_scores
	bne dhs0
	;
	rts
	
DisplayString
	ldx #$00
ds01	lda si_string,x
	sta $0E19,x
	lda #$20
	sta $0E19+40,x
	inx
	cpx si_maxlen
	bne ds01
	;
	lda #$20
	sta $0E19+40,x
	;
	lda #$77      
	ldx si_curpos
	sta $0E19+40,x
	;
	rts
	
	;
	; draw border
	;
draw_border
	lda dst
	sta dstc
	lda dst+1
	and #$FB
	sta dstc+1
	;
	ldy #$00
	lda border_chars
	sta (dst),y
	lda winc
	sta (dstc),y
	iny
	;
	ldx winw
	dex
	dex
db1	lda border_chars+1
	sta (dst),y
	lda winc
	sta (dstc),y
	iny
	dex
	bpl db1
	;
	lda border_chars+2
	sta (dst),y
	lda winc
	sta (dstc),y
	;
	jsr dst_add_40
	;
	ldx winh
	dex
	dex
	stx yloop
	;
	; ---
	;
db3	ldy #$00
	lda border_chars+3
	sta (dst),y
	lda winc
	sta (dstc),y
	iny
	;
	ldx winw
	dex
	dex
db2	lda border_chars+4
	sta (dst),y
	lda winc
	sta (dstc),y
	iny
	dex
	bpl db2
	;
	lda border_chars+5
	sta (dst),y
	lda winc
	sta (dstc),y
	;
	jsr dst_add_40
	;
	dec yloop
	bpl db3
	;
	; ---
	;
	ldy #$00
	lda border_chars+6
	sta (dst),y
	lda winc
	sta (dstc),y
	iny
	;
	ldx winw
	dex
	dex
db4	lda border_chars+7
	sta (dst),y
	lda winc
	sta (dstc),y
	iny
	dex
	bpl db4
	;
	lda border_chars+8
	sta (dst),y
	lda winc
	sta (dstc),y
	;
	rts
	
border_chars
	db $70,$40,$6E
	db $5D,$20,$5D
	db $6D,$40,$7D
	
clear_screen
	jsr sync
	;
	ldy #$00
	sty dst
	lda #$0c
	sta dst+1
	ldx #$03
	lda #$20
csc1	sta (dst),y
	iny
	bne csc1
	inc dst+1
	dex
	bpl csc1
	rts
	
copy_text
	sty winw
	;
ct2	ldy winw
	dey
ct1	lda (src),y
	sta (dst),y
	dey
	bpl ct1
	;
	jsr dst_add_40
	;
	lda winw
	clc
	adc src
	sta src
	bcc *+4
	inc src+1
	;
	dex
	bne ct2
	rts
	
grid
	db 0,0,0,0
	db 0,0,0,0
	db 0,0,0,0
	db 0,0,0,0
	
tile
	db $E9,$A0,$A0,$A0,$DF,0
	db $A0,$A0,$A0,$A0,$A0,0
	db $A0,$A0,$A0,$A0,$A0,0
	db $A0,$A0,$A0,$A0,$A0,0
	db $5F,$A0,$A0,$A0,$69,0
	
tile_colors
	db $69
	db $71,$61
	db $48,$38 
	db $28,$22
	db $02,$19
	db $29,$39,$77
	
tile_text
	db "    "
	db "  2 "
	db "  4 "
	db "  8 "
	db " 16 "
	db " 32 "
	db " 64 "
	db " 128"
	db " 256"
	db " 512"
	db "1024"
	db "2048"
	
tile_score
	db 0,0,0,0,0, 0,0,0
	db 0,0,0,0,2, 0,0,0
	db 0,0,0,0,4, 0,0,0
	db 0,0,0,0,8, 0,0,0
	db 0,0,0,1,6, 0,0,0
	db 0,0,0,3,2, 0,0,0
	db 0,0,0,6,4, 0,0,0
	db 0,0,1,2,8, 0,0,0
	db 0,0,2,5,6, 0,0,0
	db 0,0,5,1,2, 0,0,0
	db 0,1,0,2,4, 0,0,0
	db 0,2,0,4,8, 0,0,0
	
pos_table
	dw pos_corner + 0 * 240 + 0 * 6
	dw pos_corner + 0 * 240 + 1 * 6
	dw pos_corner + 0 * 240 + 2 * 6
	dw pos_corner + 0 * 240 + 3 * 6
	;
	dw pos_corner + 1 * 240 + 0 * 6
	dw pos_corner + 1 * 240 + 1 * 6
	dw pos_corner + 1 * 240 + 2 * 6
	dw pos_corner + 1 * 240 + 3 * 6
	;
	dw pos_corner + 2 * 240 + 0 * 6
	dw pos_corner + 2 * 240 + 1 * 6
	dw pos_corner + 2 * 240 + 2 * 6
	dw pos_corner + 2 * 240 + 3 * 6
	;
	dw pos_corner + 3 * 240 + 0 * 6
	dw pos_corner + 3 * 240 + 1 * 6
	dw pos_corner + 3 * 240 + 2 * 6
	dw pos_corner + 3 * 240 + 3 * 6
	
	include "key_constants.asm"
key_table
	dw null
	;
	dw $0102, MoveUp		; Joystick 1
	dw $0202, MoveDown
	dw $0402, MoveLeft
	dw $0802, MoveRight 
	;
	dw $0104, MoveUp		; Joystick 2
	dw $0204, MoveDown
	dw $0404, MoveLeft
	dw $0804, MoveRight 
	;
	dw KEY_CURSOR_RIGHT, MoveRight	; cursor keys
	dw KEY_CURSOR_LEFT, MoveLeft
	dw KEY_CURSOR_UP, MoveUp
	dw KEY_CURSOR_DOWN, MoveDown
	;
	dw KEY_ESC, gameover
	;
	dw 0
	
null
	rts

ScoreAddSub
	db 0,0,0,0,0
Score
	db 0,0,0,0,0	
Name
	db "     "
si_string = Name

EnterYourName
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "[",$1B
	cmap "]",$1D
	db "   ENTER   "
	db " YOUR NAME "
	db "           "
	db "  [     ]  "
	
HighScores
	db " HIGH SCORES "
	
Congratulations
	db "CONGRATULATIONS !"
	
Intro
	db "USE CURSOR OR JOY TO MOVE TILES."
	db "WHEN TILES WITH  THE SAME NUMBER"
	db "TOUCH, THEY MERGE INTO ONE. WHEN"
	db "A 2048 TILE IS CREATED, YOU WIN!"
	cmap

Logo	
	db $FE,$E2,$FC,$6C,$EC,$FB,$7B,$20,$6C,$A0,$6C,$EC,$FB,$7B
	db $20,$6C,$EC,$E1,$61,$E1,$61,$62,$E2,$A0,$7C,$FC,$FE,$7E
	db $FE,$7E,$20,$E1,$61,$E1,$61,$E2,$E2,$A0,$E1,$61,$E1,$61
	db $E2,$E2,$E2,$20,$E2,$E2,$20,$20,$20,$E2,$20,$E2,$E2,$20
	db $20,$20,$20,$03,$0F,$04,$05,$04,$20,$02,$19,$20,$20,$20
	db $20,$03,$13,$01,$02,$0F,$20,$0F,$06,$20,$0C,$0F,$04,$20

	include "keyboard.asm"		; the only keyboard handler you'll ever need
	include "random.asm"		; pseudo-random numbers
	include "highscore.asm"		; a high score handler
	include "string_input.asm"	; nice string input with insert/delete, etc.
;eof